package com.unipi.talepis.demo689;

import android.os.AsyncTask;
import android.os.CountDownTimer;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.TextView;

public class MainActivity extends AppCompatActivity {
    static TextView textView;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);
        textView = findViewById(R.id.textView);
        /*MyAsyncTask asyncTask = new AsyncTask<Params, Progress, Result>();
        asyncTask.execute();*/
    }
    class MyAsyncTask extends AsyncTask<String,String,String>{

        @Override
        protected void onPreExecute() {
            super.onPreExecute();
        }

        @Override
        protected void onPostExecute(String s) {
            super.onPostExecute(s);
        }

        @Override
        protected void onProgressUpdate(String... values) {
            super.onProgressUpdate(values);
        }

        @Override
        protected String doInBackground(String... strings) {
            return null;
        }
    }
    public void go4(View view){
        new CountDownTimer(20000,1000) {
            int counter;
            @Override
            public void onTick(long millisUntilFinished) {
                counter++;
                textView.setText(String.valueOf(counter));
            }

            @Override
            public void onFinish() {
                textView.setText("Finished!");
            }
        }.start();
    }
    public void go3(View view){
        new Thread(()->{
            for (int i=1;i<=10;i++){
                try {
                    Thread.sleep(1000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                int finalI = i;
                runOnUiThread(()->{
                    textView.setText(String.valueOf(finalI));
                });
            }
        }).start();
    }
    public void go2(View view){
        new Thread(new Runnable() {
            @Override
            public void run() {
                try {
                    Thread.sleep(5000);
                } catch (InterruptedException e) {
                    e.printStackTrace();
                }
                runOnUiThread(new Runnable() {
                    @Override
                    public void run() {
                        textView.setText("Updated!");
                    }
                });
            }
        }).start();

    }
    public void go(View view){
        MyThread myThread = new MyThread();
        myThread.start();
        new Thread(){
            @Override
            public void run() {
                System.out.println("hello from anonymous Thread");
                runOnUiThread(()->
                {textView.setText("hello from anonymous Thread");});
            }
        }.start();
        new Thread(new Runnable() {
            @Override
            public void run() {
                System.out.println("hello from anonymous Runnable");
            }
        }).start();
        new Thread(()->{
            System.out.println("hello from lambda!");
        }).start();
    }

}
